#include "macro.S"

	.bss
 	.set polynomial_reflected, 0b10001100

	.global crc8_check
crc8_check:
	.long 0

	.text

.global checkCRC8_bytes
checkCRC8_bytes:
/*
	char CRC8(const char *data,int length)
	{
	   char crc = 0x00;
	   char extract;
	   char sum;
	   for(int i=0;i<length;i++)
	   {
	      extract = *data;
	      for (char tempI = 8; tempI; tempI--)
	      {
	         sum = (crc ^ extract) & 0x01;
	         crc >>= 1;
	         if (sum)
	            crc ^= 0x8C;
	         extract >>= 1;
	      }
	      data++;
	   }
	   return crc;
	}
*/
	move r2, 0x00 //init CRC Shift register to zero / char crc = 0x00;
	move r0, 0    //Bytes counter / for(int i=0
	move r1, scratchpad_memory //Where Bytes are stored
checkCRC8_bytes_loop:
	push r0      //Save counter and reuse R0 for other things
	ld r0, r1, 0
	add r1, r1, 1   // Go to next Byte / data++
	push r1         // Save romid reference and reuse R1 for XOR
	//extract = *data;
	//for (char tempI = 8; tempI; tempI--)
	//{
	//  sum = (crc ^ extract) & 0x01;
	xor r1, r2, r0  // XOR Macro needs three registers in order to work
	move r2, r1     // Move result back to R2, R2 always store CRC shift register

	psr
	jump checkCRC8_oneByte

	pop r1
	pop r0
	add r0, r0, 1 //i++)
	jumpr checkCRC8_bytes_loop, 8, lt //i<length;

	ret

.global checkCRC8_oneByte
checkCRC8_oneByte:
	stage_rst
one_byte_loop:
	move r1, polynomial_reflected
	and r0, r2, 0x01 // Loads fall-off bit before rsh.
	rsh r2, r2, 1 //Shifting right by 1 bit, this fall-off bit was saved.
	//for (char tempI = 8; tempI; tempI--)
	//{
	//  sum = (crc ^ extract) & 0x01;
	//  crc >>= 1;
	//  if (sum)
	//    crc ^= 0x8C;
	jumpr bit0_no_XOR, 1, lt
bit1_do_XOR:
	xor r0, r2, r1
	move r2, r0
bit0_no_XOR:
	stage_inc 1
	jumps one_byte_loop, 8, LT
	ret
